package messaging;
import java.io.*;

class SocketProtocolMessageReader
{
	public static String readMessage(Reader reader)
			throws java.io.IOException
	{
		StringBuffer strBuf = new StringBuffer();
		int length = 4096;
		char [] cBuf = new char[length];
		int offset = 0;
		int iReadCount = 4096;
		int totalBytesRead = 0;


		int iByteCount = readByteCount(reader);
//		System.out.println("byte count is: " + iByteCount);

		while ( totalBytesRead < iByteCount)
		{
			int bytesRemaining = iByteCount - totalBytesRead;
			int bytesToRead = bytesRemaining;
			if ( bytesRemaining > length )
				bytesRemaining = length;

			iReadCount = reader.read(cBuf, offset, bytesRemaining);
			if ( iReadCount < 0 )
			{
				break;
			}
			totalBytesRead += iReadCount;
//						System.out.println("Received " + iReadCount + " chars.");
			strBuf.append(cBuf, offset, iReadCount);
		}
		return strBuf.toString();
	}

	public static int readByteCount(Reader reader)
			throws java.io.IOException
	{
		char ch = 1;;
		char chBuf [] = new char[64];
		int i =0;

		while ( ch != 0 && i < 63 )
		{
			ch = (char) reader.read();
			chBuf[i] = ch;
			i++;
		}

		chBuf[i] = 0;

		String strRead = new String(chBuf, 0, i-1);
		int iVal;
		try
		{
			iVal = ( new Integer(strRead)).intValue();
		}
		catch (java.lang.RuntimeException exc)
		{
			System.err.println("Could not parse string into number *" + strRead + "*");
			throw exc;
		}
		return iVal;
	}
}